<?xml version="1.0"?>

<xsl:stylesheet
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
	xmlns:j2ee="http://java.sun.com/xml/ns/j2ee">
	<xsl:output method="xml" indent="yes"/>
        <xsl:param name="dfltctxroot"/>
        <xsl:param name="flowctxroot"/>
        
	<xsl:template name="globalReplace"> 
 	  <xsl:param name="outputString"/> 
	  <xsl:param name="target"/> 
          <xsl:param name="replacement"/> 
          <xsl:choose> 
            <xsl:when test="contains($outputString,$target)"> 
              <xsl:value-of select= "concat(substring-before($outputString,$target), $replacement)"/> 
              <xsl:call-template name="globalReplace"> 
                <xsl:with-param name="outputString" select="substring-after($outputString,$target)"/> 
                <xsl:with-param name="target" select="$target"/> 
                <xsl:with-param name="replacement" select="$replacement"/> 
              </xsl:call-template> 
            </xsl:when> 
            <xsl:otherwise> 
              <xsl:value-of select="$outputString"/> 
            </xsl:otherwise> 
          </xsl:choose> 
        </xsl:template> 

	<xsl:template match="/j2ee:application/j2ee:module/j2ee:web/j2ee:context-root/text()">
          <xsl:call-template name="globalReplace">
            <xsl:with-param name="outputString" select="."/>
            <xsl:with-param name="target" select="$dfltctxroot"/>
            <xsl:with-param name="replacement" select="$flowctxroot"/>
          </xsl:call-template>
        </xsl:template>


        <xsl:template match="@*|*">
          <xsl:copy>
            <xsl:apply-templates select="@*|node()"/>
          </xsl:copy>

</xsl:template>


</xsl:stylesheet>




