<?xml version="1.0"?>

<xsl:stylesheet
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
	xmlns:j2ee="http://java.sun.com/xml/ns/j2ee">
	<xsl:output method="xml" indent="yes"/>
        <xsl:param name="urlsearch"/>
        <xsl:param name="urlreplace"/>
        

	<xsl:template name="globalReplace"> 
 	  <xsl:param name="outputString"/> 
	  <xsl:param name="target"/> 
          <xsl:param name="replacement"/> 
          <xsl:choose> 
            <xsl:when test="contains($outputString,$target)"> 
              <xsl:value-of select= "$replacement"/> 
            </xsl:when> 
            <xsl:otherwise> 
              <xsl:value-of select="$outputString"/> 
            </xsl:otherwise> 
          </xsl:choose> 
        </xsl:template> 

	<xsl:template match="/j2ee:web-app/j2ee:servlet-mapping/j2ee:url-pattern//text()">
          <xsl:call-template name="globalReplace">
            <xsl:with-param name="outputString" select="."/>
            <xsl:with-param name="target" select="$urlsearch"/>
            <xsl:with-param name="replacement" select="$urlreplace"/>
          </xsl:call-template>

        </xsl:template>

	<xsl:template match="@*|*">
          <xsl:copy>
            <xsl:apply-templates select="@*|node()"/>
          </xsl:copy>

        </xsl:template>


</xsl:stylesheet>




