<?xml version="1.0"?>

<xsl:stylesheet
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
	xmlns:j2ee="http://java.sun.com/xml/ns/j2ee">
	<xsl:output method="xml" indent="yes"/>
        
        <xsl:param name="flowname"/>
        <xsl:param name="urlpattern1"/>
        <xsl:param name="urlpattern2"/>
        <xsl:param name="urlpattern3"/>
        <xsl:param name="urlpattern4"/>

       <xsl:variable name="srfcount" select="count(/j2ee:web-app/j2ee:servlet/j2ee:security-role-ref)"/>

                

	<xsl:template match="/j2ee:web-app/j2ee:servlet/j2ee:servlet-class">
                                            
               <xsl:copy-of select="."/>
               <xsl:if test="$srfcount = 0">
                 <xsl:element name="security-role-ref" namespace="http://java.sun.com/xml/ns/j2ee">
	 	  <xsl:element name="description" namespace="http://java.sun.com/xml/ns/j2ee">
                  <xsl:value-of select="concat('Role for accessing ',$flowname)"/>
		  </xsl:element>
		  <xsl:element name="role-name" namespace="http://java.sun.com/xml/ns/j2ee">
                  <xsl:value-of select="concat($flowname,'Role')"/>
                  </xsl:element>
                  <xsl:element name="role-link" namespace="http://java.sun.com/xml/ns/j2ee">
                  <xsl:value-of select="concat($flowname,'Role')"/>
                  </xsl:element>
	        </xsl:element>
              </xsl:if>         	
           </xsl:template>

        <xsl:template match="/j2ee:web-app/j2ee:welcome-file-list">
            <xsl:copy-of select="."/>
            <xsl:if test="$srfcount = 0">
		<xsl:element name="security-constraint" namespace="http://java.sun.com/xml/ns/j2ee">
			<xsl:element name="display-name" namespace="http://java.sun.com/xml/ns/j2ee">
		   <xsl:value-of select="concat($flowname,'URLConstraint')"/>
                </xsl:element>
		<xsl:element name="web-resource-collection" namespace="http://java.sun.com/xml/ns/j2ee">
		   <xsl:element name="web-resource-name" namespace="http://java.sun.com/xml/ns/j2ee">URL</xsl:element>

                   <xsl:choose>
                     <xsl:when test="contains($urlpattern1,'NotUsed')">
                     </xsl:when>
                     <xsl:otherwise>
                       <xsl:element name="url-pattern" namespace="http://java.sun.com/xml/ns/j2ee">
                           <xsl:value-of select= "$urlpattern1"/>
                       </xsl:element>
                     </xsl:otherwise>
                   </xsl:choose>

                   <xsl:choose>
                     <xsl:when test="contains($urlpattern2,'NotUsed')">
                     </xsl:when>
                     <xsl:otherwise>
                       <xsl:element name="url-pattern" namespace="http://java.sun.com/xml/ns/j2ee">
                           <xsl:value-of select= "$urlpattern2"/>
                       </xsl:element>
                     </xsl:otherwise>
                   </xsl:choose>

                   <xsl:choose>
                     <xsl:when test="contains($urlpattern3,'NotUsed')">
                     </xsl:when>
                     <xsl:otherwise>
                       <xsl:element name="url-pattern" namespace="http://java.sun.com/xml/ns/j2ee">
                           <xsl:value-of select= "$urlpattern3"/>
                       </xsl:element>
                     </xsl:otherwise>
                   </xsl:choose>

                   <xsl:choose>
                     <xsl:when test="contains($urlpattern4,'NotUsed')">
                     </xsl:when>
                     <xsl:otherwise>
                       <xsl:element name="url-pattern" namespace="http://java.sun.com/xml/ns/j2ee">
                           <xsl:value-of select= "$urlpattern4"/>
                       </xsl:element>
                     </xsl:otherwise>
                   </xsl:choose>

			<xsl:element name="http-method" namespace="http://java.sun.com/xml/ns/j2ee">GET</xsl:element>
			<xsl:element name="http-method" namespace="http://java.sun.com/xml/ns/j2ee">PUT</xsl:element>
			<xsl:element name="http-method" namespace="http://java.sun.com/xml/ns/j2ee">HEAD</xsl:element>
			<xsl:element name="http-method" namespace="http://java.sun.com/xml/ns/j2ee">TRACE</xsl:element>
			<xsl:element name="http-method" namespace="http://java.sun.com/xml/ns/j2ee">POST</xsl:element>
			<xsl:element name="http-method" namespace="http://java.sun.com/xml/ns/j2ee">DELETE</xsl:element>
			<xsl:element name="http-method" namespace="http://java.sun.com/xml/ns/j2ee">OPTIONS</xsl:element>
	        </xsl:element>
		<xsl:element name="auth-constraint" namespace="http://java.sun.com/xml/ns/j2ee">
			<xsl:element name="description" namespace="http://java.sun.com/xml/ns/j2ee">Authority Constraint</xsl:element>
			<xsl:element name="role-name" namespace="http://java.sun.com/xml/ns/j2ee">
                             <xsl:value-of select="concat($flowname,'Role')"/>
                         </xsl:element>
		</xsl:element>
	  </xsl:element>
	  <xsl:element name="login-config" namespace="http://java.sun.com/xml/ns/j2ee">
		<xsl:element name="auth-method" namespace="http://java.sun.com/xml/ns/j2ee">BASIC</xsl:element>
		<xsl:element name="realm-name" namespace="http://java.sun.com/xml/ns/j2ee">Web Services Access</xsl:element>
	  </xsl:element>
          <xsl:element name="security-role" namespace="http://java.sun.com/xml/ns/j2ee">
		<xsl:element name="description" namespace="http://java.sun.com/xml/ns/j2ee">
                   <xsl:value-of select="concat('Role for accessing ',$flowname)"/>
		</xsl:element>
		<xsl:element name="role-name" namespace="http://java.sun.com/xml/ns/j2ee">
                   <xsl:value-of select="concat($flowname,'Role')"/>
                </xsl:element>
	   </xsl:element>
	  </xsl:if>
         </xsl:template>

	<xsl:template match="@*|*">
          <xsl:copy>
            <xsl:apply-templates select="@*|node()"/>
          </xsl:copy>

        </xsl:template>


</xsl:stylesheet>




